'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _ConfirmRoot = require('../ConfirmRoot');

var _ConfirmRoot2 = _interopRequireDefault(_ConfirmRoot);

var _store = require('../store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var node = null;

afterEach(function () {
  node.unmount();
});

test('it should throw when more than 1 instance is mounted', function () {
  var Child = jest.fn(function () {
    return _react2.default.createElement('div', null);
  });
  node = (0, _enzyme.mount)(_react2.default.createElement(
    _ConfirmRoot2.default,
    null,
    Child
  ));

  expect(function () {
    (0, _enzyme.mount)(_react2.default.createElement(
      _ConfirmRoot2.default,
      null,
      Child
    ));
  }).toThrow('Only a single ConfirmRoot can be mounted at a time.');
});

test('it should have props', function () {
  var Child = jest.fn(function () {
    return _react2.default.createElement('div', null);
  });
  node = (0, _enzyme.mount)(_react2.default.createElement(
    _ConfirmRoot2.default,
    null,
    Child
  ));
  var props = Child.mock.calls[0][0];

  expect(Object.keys(props)).toEqual(['active', 'text', 'options', 'actions']);
  expect(Object.keys(props.actions)).toEqual(['proceed', 'dismiss']);
});

test('it should proceed', function () {
  var spy = jest.spyOn(_store.actions, 'proceed');
  var Child = function Child(_ref) {
    var actions = _ref.actions;
    return _react2.default.createElement('button', { onClick: actions.proceed });
  };
  node = (0, _enzyme.mount)(_react2.default.createElement(
    _ConfirmRoot2.default,
    null,
    Child
  ));

  node.find('button').simulate('click');
  expect(spy).toHaveBeenCalled();

  spy.mockReset();
  spy.mockRestore();
});

test('it should dismiss', function () {
  var spy = jest.spyOn(_store.actions, 'dismiss');
  var Child = function Child(_ref2) {
    var actions = _ref2.actions;
    return _react2.default.createElement('button', { onClick: actions.dismiss });
  };
  node = (0, _enzyme.mount)(_react2.default.createElement(
    _ConfirmRoot2.default,
    null,
    Child
  ));

  node.find('button').simulate('click');
  expect(spy).toHaveBeenCalled();

  spy.mockReset();
  spy.mockRestore();
});