'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Provider = exports.connect = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function mapActions(actions, store) {
    if (typeof actions === 'function') {
        actions = actions(store);
    }
    var mapped = {};
    for (var i in actions) {
        mapped[i] = store.action(actions[i]);
    }
    return mapped;
}

function select(properties) {
    if (typeof properties === 'string') {
        properties = properties.split(',');
    }
    return function (state) {
        var selected = {};
        for (var i = 0; i < properties.length; i++) {
            selected[properties[i]] = state[properties[i]];
        }
        return selected;
    };
}

function assign(obj, props) {
    for (var i in props) {
        obj[i] = props[i];
    }
    return obj;
}

var CONTEXT_TYPES = {
    store: function store() {}
};
function connect(mapStateToProps, actions) {
    if (typeof mapStateToProps !== 'function') {
        mapStateToProps = select(mapStateToProps || []);
    }
    return function (Child) {
        var Wrapper = function (_Component) {
            _inherits(Wrapper, _Component);

            function Wrapper() {
                var _ref;

                var _temp, _this, _ret;

                _classCallCheck(this, Wrapper);

                for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
                    args[_key] = arguments[_key];
                }

                return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Wrapper.__proto__ || Object.getPrototypeOf(Wrapper)).call.apply(_ref, [this].concat(args))), _this), _this.state = mapStateToProps(_this.context.store ? _this.context.store.getState() : {}, _this.props), _this.boundActions = actions ? mapActions(actions, _this.context.store) : { store: _this.context.store }, _this.update = function () {
                    var mapped = mapStateToProps(_this.context.store ? _this.context.store.getState() : {}, _this.props);
                    for (var i in mapped) {
                        if (mapped[i] !== _this.state[i]) {
                            _this.state = mapped;
                            return _this.setState(null);
                        }
                    }for (var _i in _this.state) {
                        if (!(_i in mapped)) {
                            _this.state = mapped;
                            return _this.setState(null);
                        }
                    }
                }, _temp), _possibleConstructorReturn(_this, _ret);
            }

            _createClass(Wrapper, [{
                key: 'componentDidMount',
                value: function componentDidMount() {
                    this.context.store.subscribe(this.update);
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    this.context.store.unsubscribe(this.update);
                }
            }, {
                key: 'render',
                value: function render() {
                    return (0, _react.createElement)(Child, assign(assign(assign({}, this.boundActions), this.props), this.state));
                }
            }]);

            return Wrapper;
        }(_react.Component);

        Wrapper.contextTypes = CONTEXT_TYPES;
        return Wrapper;
    };
}

var Provider = function (Component$$1) {
    function Provider() {
        Component$$1.apply(this, arguments);
    }

    if (Component$$1) Provider.__proto__ = Component$$1;
    Provider.prototype = Object.create(Component$$1 && Component$$1.prototype);
    Provider.prototype.constructor = Provider;

    Provider.prototype.getChildContext = function getChildContext() {
        return {
            store: this.props.store
        };
    };
    Provider.prototype.render = function render() {
        return _react.Children.only(this.props.children);
    };

    return Provider;
}(_react.Component);
Provider.childContextTypes = CONTEXT_TYPES;

exports.connect = connect;
exports.Provider = Provider;
//# sourceMappingURL=react.es.js.map